@using System
@using ChartJs.Blazor.Common.Axes
@using ChartJs.Blazor.LineChart
@using ChartJs.Blazor.Common.Enums
@using ChartJs.Blazor.Common.Time

@inject HttpClient Http
@inject GlobalAppState GlobalAppState
@inject NavigationManager NavManager
@inject IMatToaster Toaster
@implements IDisposable
@page "/priceindices"

<FIOWebServer.Components.LoadingWrapper @bind-ProgressCount="CurrentProgress" TotalProgress="2">
<h1>Price Indices</h1>

<div>
    <div class="flex-container" style="display: flex; flex-flow: row wrap; justify-content: flex-start; height: 10%; margin-bottom:10px">
        <div style="min-height:20px; min-width: 150px; margin-right:50px; width: fit-content; flex-grow: 0; flex-shrink: 0">
            <div>
                Number of days:
                &ensp;
                <AntDesign.InputNumber @bind-Value="@state.NumberOfDays" DefaultValue="30" Min="0" Max="200"></AntDesign.InputNumber>
            </div>
        </div>
        <div style="min-height:20px; min-width: 150px; margin-right:10px; width: fit-content; flex-grow: 0; flex-shrink: 0">
            <div>
                <Checkbox Checked="@state.average" CheckedChange="@(() => {state.average = !state.average;})">Show moving averages</Checkbox>
            </div>
        </div>
        <div style="min-height:20px; min-width: 150px; margin-right:10px; width: fit-content; flex-grow: 0; flex-shrink: 0">
            <div>
                @if (state.UpdateLoading)
                {
                    <Spin size="large" />
                }
                else
                {
            <MatThemeProvider Theme="@blackTheme">
                <MatButton Raised="true" Class="mdc-toast-info" Icon="update" OnClick="UpdateClick">Update</MatButton>
            </MatThemeProvider>
                }
            </div>
        </div>
    </div>
</div>
</FIOWebServer.Components.LoadingWrapper>

<div hidden="@HideCharts">
    <h3>
        Pioneer Consumable Cost Index
        <Popover Title="" Placement="@Placement.BottomLeft">
            <ContentTemplate>
                <p>
                    Cost of 100 pioneers/day scaled to 100.0 for market maker sells
                </p>
            </ContentTemplate>
            <ChildContent>
                <MatIcon style="transform:scale(0.65)" Icon="info" />
            </ChildContent>
        </Popover>
    </h3>

    <Chart Config="consumablesConfig" @ref="consumablesChart"></Chart>
    <br />
    <h3>
        Basic Prefab Cost Index
        <Popover Title="" Placement="@Placement.BottomLeft">
            <ContentTemplate>
                <p>
                    Cost of the average T1 building scaled to 100.0 for market maker sells
                </p>
            </ContentTemplate>
            <ChildContent>
                <MatIcon style="transform:scale(0.65)" Icon="info" />
            </ChildContent>
        </Popover>
    </h3>
    <Chart Config="buildingConfig" @ref="buildingChart"></Chart>
</div>